Class | Fog::Compute::AWS::Real

In:

lib/fog/aws/compute.rb
lib/fog/aws/requests/compute/allocate_address.rb
lib/fog/aws/requests/compute/associate_address.rb
lib/fog/aws/requests/compute/associate_dhcp_options.rb
lib/fog/aws/requests/compute/attach_internet_gateway.rb
lib/fog/aws/requests/compute/attach_network_interface.rb
lib/fog/aws/requests/compute/attach_volume.rb
lib/fog/aws/requests/compute/authorize_security_group_ingress.rb
lib/fog/aws/requests/compute/cancel_spot_instance_requests.rb
lib/fog/aws/requests/compute/create_dhcp_options.rb
lib/fog/aws/requests/compute/create_image.rb
lib/fog/aws/requests/compute/create_internet_gateway.rb
lib/fog/aws/requests/compute/create_key_pair.rb
lib/fog/aws/requests/compute/create_network_interface.rb
lib/fog/aws/requests/compute/create_placement_group.rb
lib/fog/aws/requests/compute/create_security_group.rb
lib/fog/aws/requests/compute/create_snapshot.rb
lib/fog/aws/requests/compute/create_spot_datafeed_subscription.rb
lib/fog/aws/requests/compute/create_subnet.rb
lib/fog/aws/requests/compute/create_tags.rb
lib/fog/aws/requests/compute/create_volume.rb
lib/fog/aws/requests/compute/create_vpc.rb
lib/fog/aws/requests/compute/delete_dhcp_options.rb
lib/fog/aws/requests/compute/delete_internet_gateway.rb
lib/fog/aws/requests/compute/delete_key_pair.rb
lib/fog/aws/requests/compute/delete_network_interface.rb
lib/fog/aws/requests/compute/delete_placement_group.rb
lib/fog/aws/requests/compute/delete_security_group.rb
lib/fog/aws/requests/compute/delete_snapshot.rb
lib/fog/aws/requests/compute/delete_spot_datafeed_subscription.rb
lib/fog/aws/requests/compute/delete_subnet.rb
lib/fog/aws/requests/compute/delete_tags.rb
lib/fog/aws/requests/compute/delete_volume.rb
lib/fog/aws/requests/compute/delete_vpc.rb
lib/fog/aws/requests/compute/deregister_image.rb
lib/fog/aws/requests/compute/describe_addresses.rb
lib/fog/aws/requests/compute/describe_availability_zones.rb
lib/fog/aws/requests/compute/describe_dhcp_options.rb
lib/fog/aws/requests/compute/describe_images.rb
lib/fog/aws/requests/compute/describe_instance_status.rb
lib/fog/aws/requests/compute/describe_instances.rb
lib/fog/aws/requests/compute/describe_internet_gateways.rb
lib/fog/aws/requests/compute/describe_key_pairs.rb
lib/fog/aws/requests/compute/describe_network_interface_attribute.rb
lib/fog/aws/requests/compute/describe_network_interfaces.rb
lib/fog/aws/requests/compute/describe_placement_groups.rb
lib/fog/aws/requests/compute/describe_regions.rb
lib/fog/aws/requests/compute/describe_reserved_instances.rb
lib/fog/aws/requests/compute/describe_reserved_instances_offerings.rb
lib/fog/aws/requests/compute/describe_security_groups.rb
lib/fog/aws/requests/compute/describe_snapshots.rb
lib/fog/aws/requests/compute/describe_spot_datafeed_subscription.rb
lib/fog/aws/requests/compute/describe_spot_instance_requests.rb
lib/fog/aws/requests/compute/describe_spot_price_history.rb
lib/fog/aws/requests/compute/describe_subnets.rb
lib/fog/aws/requests/compute/describe_tags.rb
lib/fog/aws/requests/compute/describe_volume_status.rb
lib/fog/aws/requests/compute/describe_volumes.rb
lib/fog/aws/requests/compute/describe_vpcs.rb
lib/fog/aws/requests/compute/detach_internet_gateway.rb
lib/fog/aws/requests/compute/detach_network_interface.rb
lib/fog/aws/requests/compute/detach_volume.rb
lib/fog/aws/requests/compute/disassociate_address.rb
lib/fog/aws/requests/compute/get_console_output.rb
lib/fog/aws/requests/compute/get_password_data.rb
lib/fog/aws/requests/compute/import_key_pair.rb
lib/fog/aws/requests/compute/modify_image_attribute.rb
lib/fog/aws/requests/compute/modify_instance_attribute.rb
lib/fog/aws/requests/compute/modify_network_interface_attribute.rb
lib/fog/aws/requests/compute/modify_snapshot_attribute.rb
lib/fog/aws/requests/compute/monitor_instances.rb
lib/fog/aws/requests/compute/purchase_reserved_instances_offering.rb
lib/fog/aws/requests/compute/reboot_instances.rb
lib/fog/aws/requests/compute/register_image.rb
lib/fog/aws/requests/compute/release_address.rb
lib/fog/aws/requests/compute/request_spot_instances.rb
lib/fog/aws/requests/compute/reset_network_interface_attribute.rb
lib/fog/aws/requests/compute/revoke_security_group_ingress.rb
lib/fog/aws/requests/compute/run_instances.rb
lib/fog/aws/requests/compute/start_instances.rb
lib/fog/aws/requests/compute/stop_instances.rb
lib/fog/aws/requests/compute/terminate_instances.rb
lib/fog/aws/requests/compute/unmonitor_instances.rb

Parent: | Object

deprecation

### Methods

allocate_address associate_address associate_dhcp_options attach_internet_gateway attach_network_interface attach_volume authorize_security_group_ingress cancel_spot_instance_requests create_dhcp_options create_image create_internet_gateway create_key_pair create_network_interface create_placement_group create_security_group create_snapshot create_spot_datafeed_subscription create_subnet create_tags create_volume create_vpc delete_dhcp_options delete_internet_gateway delete_key_pair delete_network_interface delete_placement_group delete_security_group delete_snapshot delete_spot_datafeed_subscription delete_subnet delete_tags delete_volume delete_vpc deregister_image describe_addresses describe_availability_zones describe_dhcp_options describe_images describe_instance_status describe_instances describe_internet_gateways describe_key_pairs describe_network_interface_attribute describe_network_interfaces describe_placement_groups describe_regions describe_reserved_instances describe_reserved_instances_offerings describe_security_groups describe_snapshots describe_spot_datafeed_subscription describe_spot_instance_requests describe_spot_price_history describe_subnets describe_tags describe_volume_status describe_volumes describe_vpcs detach_internet_gateway detach_network_interface detach_volume disassociate_address get_console_output get_password_data import_key_pair modify_image_attribute modify_image_attributes modify_instance_attribute modify_instance_attributes modify_network_interface_attribute modify_snapshot_attribute monitor_instances new purchase_reserved_instances_offering reboot_instances register_image release_address reload request_spot_instances reset_network_interface_attribute revoke_security_group_ingress run_instances start_instances stop_instances terminate_instances unmonitor_instances

### Included Modules

Fog::AWS::CredentialFetcher::ConnectionMethods

### Attributes

region

[RW]

Initialize connection to EC2

#### Notes

options parameter must include values for :aws_access_key_id and :aws_secret_access_key in order to create a connection

#### Examples

      sdb = SimpleDB.new(
       :aws_access_key_id => your_aws_access_key_id,
       :aws_secret_access_key => your_aws_secret_access_key
      )

#### Parameters

- options<~Hash> - config arguments for connection. Defaults to {}.
  - region<~String> - optional region to use. For instance, ‘eu-west-1’, ‘us-east-1’, and etc.
  - aws_session_token<~String> - when using Session Tokens or Federated Users, a session_token must be presented

#### Returns

- EC2 object with connection to aws.

### Public Class methods

new(options={})

### Public Instance methods

allocate_address(domain='standard')

Acquire an elastic IP address.

#### Parameters

- domain<~String> - Type of EIP, either standard or vpc

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘publicIp’<~String> - The acquired address
    - ‘requestId’<~String> - Id of the request

Amazon API Reference

associate_address(instance_id=nil, public_ip=nil, network_interface_id=nil, allocation_id=nil)

Associate an elastic IP address with an instance

#### Parameters

- instance_id<~String> - Id of instance to associate address with (conditional)
- public_ip<~String> - Public ip to assign to instance (conditional)
- network_interface_id<~String> - Id of a nic to associate address with (required in a vpc instance with more than one nic) (conditional)
- allocation_id<~String> - Allocation Id to associate address with (vpc only) (conditional)

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?
    - ‘associationId’<~String> - association Id for eip to node (vpc only)

Amazon API Reference

associate_dhcp_options(dhcp_options_id, vpc_id)

#### Parameters

- dhcp_options_id<~String> - The ID of the DHCP options you want to associate with the VPC, or "default" if you want the VPC to use no DHCP options.
- vpc_id<~String> - The ID of the VPC

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

attach_internet_gateway(internet_gateway_id, vpc_id)

Attaches an Internet gateway to a VPC, enabling connectivity between the Internet and the VPC

#### Parameters

- internet_gateway_id<~String> - The ID of the Internet gateway to attach
- vpc_id<~String> - The ID of the VPC

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

attach_network_interface(nic_id, instance_id, device_index)

Attach a network interface

#### Parameters

- networkInterfaceId<~String> - ID of the network interface to attach
- instanceId<~String> - ID of the instance that will be attached to the network interface
- deviceIndex<~Integer> - index of the device for the network interface attachment on the instance

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘attachmentId’<~String> - ID of the attachment

Amazon API Reference

attach_volume(instance_id, volume_id, device)

Attach an Amazon EBS volume with a running instance, exposing as specified device

#### Parameters

- instance_id<~String> - Id of instance to associate volume with
- volume_id<~String> - Id of amazon EBS volume to associate with instance
- device<~String> - Specifies how the device is exposed to the instance (e.g. "/dev/sdh")

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘attachTime’<~Time> - Time of attachment was initiated at
    - ‘device’<~String> - Device as it is exposed to the instance
    - ‘instanceId’<~String> - Id of instance for volume
    - ‘requestId’<~String> - Id of request
    - ‘status’<~String> - Status of volume
    - ‘volumeId’<~String> - Reference to volume

Amazon API Reference

authorize_security_group_ingress(group_name, options = {})

Add permissions to a security group

#### Parameters

- group_name<~String> - Name of group, optional (can also be specifed as GroupName in options)
- options<~Hash>:
  - ‘GroupName’<~String> - Name of security group to modify
  - ‘GroupId’<~String> - Id of security group to modify
  - ‘SourceSecurityGroupName’<~String> - Name of security group to authorize
  - ‘SourceSecurityGroupOwnerId’<~String> - Name of owner to authorize

  or

  - ‘CidrIp’<~String> - CIDR range
  - ‘FromPort’<~Integer> - Start of port range (or -1 for ICMP wildcard)
  - ‘IpProtocol’<~String> - Ip protocol, must be in [‘tcp’, ‘udp’, ‘icmp’]
  - ‘ToPort’<~Integer> - End of port range (or -1 for ICMP wildcard)

  or

  - ‘IpPermissions’<~Array>:
    - permission<~Hash>:
      - ‘FromPort’<~Integer> - Start of port range (or -1 for ICMP wildcard)
      - ‘Groups’<~Array>:
        - group<~Hash>:
          - ‘GroupName’<~String> - Name of security group to authorize
          - ‘UserId’<~String> - Name of owner to authorize
      - ‘IpProtocol’<~String> - Ip protocol, must be in [‘tcp’, ‘udp’, ‘icmp’]
      - ‘IpRanges’<~Array>:
        - ip_range<~Hash>:
          - ‘CidrIp’<~String> - CIDR range
      - ‘ToPort’<~Integer> - End of port range (or -1 for ICMP wildcard)

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

cancel_spot_instance_requests(spot_instance_request_id)

Terminate specified spot instance requests

#### Parameters

- spot_instance_request_id<~Array> - Ids of instances to terminates

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> id of request
    - ‘spotInstanceRequestSet’<~Array>:
      - ‘spotInstanceRequestId’<~String> - id of cancelled spot instance
      - ‘state’<~String> - state of cancelled spot instance

Amazon API Reference

create_dhcp_options(dhcp_configurations = {})

Creates a set of DHCP options for your VPC

#### Parameters

- DhcpConfigurationOptions<~Hash> - hash of key value dhcp options to assign

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request

Amazon API Reference

create_image(instance_id, name, description, no_reboot = false)

Create a bootable EBS volume AMI

#### Parameters

- instance_id<~String> - Instance used to create image.
- name<~Name> - Name to give image.
- description<~Name> - Description of image.
- no_reboot<~Boolean> - Optional, whether or not to reboot the image when making the snapshot

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘imageId’<~String> - The ID of the created AMI.
    - ‘requestId’<~String> - Id of request.

Amazon API Reference

create_internet_gateway()

Creates an InternetGateway

#### Parameters

(none)

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘internetGateway’<~Array>:
- ‘attachmentSet’<~Array>: A list of VPCs attached to the Internet gateway
- ‘vpcId’<~String> - The ID of the VPC the Internet gateway is attached to.
- ‘state’<~String> - The current state of the attachment.
- ‘tagSet’<~Array>: Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value

Amazon API Reference

create_key_pair(key_name)

Create a new key pair

#### Parameters

- key_name<~String> - Unique name for key pair.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘keyFingerprint’<~String> - SHA-1 digest of DER encoded private key
    - ‘keyMaterial’<~String> - Unencrypted encoded PEM private key
    - ‘keyName’<~String> - Name of key
    - ‘requestId’<~String> - Id of request

Amazon API Reference

create_network_interface(subnetId, options = {})

Creates a network interface

#### Parameters

- subnetId<~String> - The ID of the subnet to associate with the network interface
- options<~Hash>:
  - PrivateIpAddress<~String> - The private IP address of the network interface
  - Description<~String> - The description of the network interface
  - groupSet<~Array> - The security group IDs for use by the network interface

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘networkInterface’<~Hash> - The created network interface
- ‘networkInterfaceId’<~String> - The ID of the network interface
- ‘subnetId’<~String> - The ID of the subnet
- ‘vpcId’<~String> - The ID of the VPC
- ‘availabilityZone’<~String> - The availability zone
- ‘description’<~String> - The description
- ‘ownerId’<~String> - The ID of the person who created the interface
- ‘requesterId’<~String> - The ID ot teh entity requesting this interface
- ‘requesterManaged’<~String> -
- ‘status’<~String> - "available" or "in-use"
- ‘macAddress’<~String> -
- ‘privateIpAddress’<~String> - IP address of the interface within the subnet
- ‘privateDnsName’<~String> - The private DNS name
- ‘sourceDestCheck’<~Boolean> - Flag indicating whether traffic to or from the instance is validated
- ‘groupSet’<~Hash> - Associated security groups
- ‘key’<~String> - ID of associated group
- ‘value’<~String> - Name of associated group
- ‘attachment’<~Hash>: - Describes the way this nic is attached
- ‘attachmentID’<~String>
- ‘instanceID’<~String>
- ‘association’<~Hash>: - Describes an eventual instance association
- ‘attachmentID’<~String> - ID of the network interface attachment
- ‘instanceID’<~String> - ID of the instance attached to the network interface
- ‘publicIp’<~String> - Address of the Elastic IP address bound to the network interface
- ‘ipOwnerId’<~String> - ID of the Elastic IP address owner
- ‘tagSet’<~Array>: - Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value

Amazon API Reference

create_placement_group(name, strategy)

Create a new placement group

#### Parameters

- group_name<~String> - Name of the placement group.
- strategy<~String> - Placement group strategy. Valid options in [‘cluster’]

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

create_security_group(name, description, vpc_id=nil)

Create a new security group

#### Parameters

- group_name<~String> - Name of the security group.
- group_description<~String> - Description of group.
- vpc_id<~String> - ID of the VPC

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?
    - ‘groupId’<~String> - Id of created group

Amazon API Reference

create_snapshot(volume_id, description = nil)

Create a snapshot of an EBS volume and store it in S3

#### Parameters

- volume_id<~String> - Id of EBS volume to snapshot

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘progress’<~String> - The percentage progress of the snapshot
    - ‘requestId’<~String> - id of request
    - ‘snapshotId’<~String> - id of snapshot
    - ‘startTime’<~Time> - timestamp when snapshot was initiated
    - ‘status’<~String> - state of snapshot
    - ‘volumeId’<~String> - id of volume snapshot targets

Amazon API Reference

create_spot_datafeed_subscription(bucket, prefix)

Create a spot datafeed subscription

#### Parameters

- bucket<~String> - bucket name to store datafeed in
- prefix<~String> - prefix to store data with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘spotDatafeedSubscription’<~Hash>:
      - ‘bucket’<~String> - S3 bucket where data is stored
      - ‘fault’<~Hash>:
        - ‘code’<~String> - fault code
        - ‘reason’<~String> - fault reason
      - ‘ownerId’<~String> - AWS id of account owner
      - ‘prefix’<~String> - prefix for datafeed items
      - ‘state’<~String> - state of datafeed subscription

Amazon API Reference

create_subnet(vpcId, cidrBlock, options = {})

Creates a Subnet with the CIDR block you specify.

#### Parameters

- vpcId<~String> - The ID of the VPC where you want to create the subnet.
- cidrBlock<~String> - The CIDR block you want the Subnet to cover (e.g., 10.0.0.0/16).
- options<~Hash>:
  - AvailabilityZone<~String> - The Availability Zone you want the subnet in. Default: AWS selects a zone for you (recommended)

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘subnet’<~Array>:
- ‘subnetId’<~String> - The Subnet‘s ID
- ‘state’<~String> - The current state of the Subnet. [‘pending’, ‘available’]
- ‘cidrBlock’<~String> - The CIDR block the Subnet covers.
- ‘AvailableIpAddressCount’<~Integer> - The number of unused IP addresses in the subnet (the IP addresses for any stopped instances are considered unavailable)
- ‘AvailabilityZone’<~String> - The Availability Zone the subnet is in
- ‘tagSet’<~Array>: Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value

Amazon API Reference

create_tags(resources, tags)

Adds tags to resources

#### Parameters

- resources<~String> - One or more resources to tag
- tags<~String> - hash of key value tag pairs to assign

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

create_volume(availability_zone, size, snapshot_id = nil)

Create an EBS volume

#### Parameters

- availability_zone<~String> - availability zone to create volume in
- size<~Integer> - Size in GiBs for volume. Must be between 1 and 1024.
- snapshot_id<~String> - Optional, snapshot to create volume from

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘availabilityZone’<~String> - Availability zone for volume
    - ‘createTime’<~Time> - Timestamp for creation
    - ‘size’<~Integer> - Size in GiBs for volume
    - ‘snapshotId’<~String> - Snapshot volume was created from, if any
    - ‘status‘s<~String> - State of volume
    - ‘volumeId’<~String> - Reference to volume

Amazon API Reference

create_vpc(cidrBlock, options = {})

Creates a VPC with the CIDR block you specify.

#### Parameters

- cidrBlock<~String> - The CIDR block you want the VPC to cover (e.g., 10.0.0.0/16).
- options<~Hash>:
  - InstanceTenancy<~String> - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means instances must be launched with tenancy as dedicated. please not that the documentation is incorrect instanceTenancy will not work while InstanceTenancy will

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘vpc’<~Array>:
- ‘vpcId’<~String> - The VPC‘s ID
- ‘state’<~String> - The current state of the VPC. [‘pending’, ‘available’]
- ‘cidrBlock’<~String> - The CIDR block the VPC covers.
- ‘dhcpOptionsId’<~String> - The ID of the set of DHCP options.
- ‘tagSet’<~Array>: Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value

Amazon API Reference

delete_dhcp_options(dhcp_options_id)

Deletes a set of DHCP options that you specify. Amazon VPC returns an error if the set of options you specify is currently associated with a VPC. You can disassociate the set of options by associating either a new set of options or the default options with the VPC.

     ==== Parameters
     * dhcp_options_id<~String> - The ID of the DHCP options set you want to delete.

     === Returns
     * response<~Excon::Response>:
     * body<~Hash>:
     * 'requestId'<~String> - Id of request
     * 'return'<~Boolean> - Returns true if the request succeeds.

     {Amazon API Reference}[http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-DeleteDhcpOptions.html]

delete_internet_gateway(internet_gateway_id)

Deletes an Internet gateway from your AWS account. The gateway must not be attached to a VPC

     ==== Parameters
     * internet_gateway_id<~String> - The ID of the InternetGateway you want to delete.

     === Returns
     * response<~Excon::Response>:
     * body<~Hash>:
     * 'requestId'<~String> - Id of request
     * 'return'<~Boolean> - Returns true if the request succeeds.

     {Amazon API Reference}[http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-DeleteInternetGateway.html]

delete_key_pair(key_name)

Delete a key pair that you own

#### Parameters

- key_name<~String> - Name of the key pair.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_network_interface(network_interface_id)

Deletes a network interface.

#### Parameters

- network_interface_id<~String> - The ID of the network interface you want to delete.

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

delete_placement_group(name)

Delete a placement group that you own

#### Parameters

- group_name<~String> - Name of the placement group.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_security_group(name, id = nil)

Delete a security group that you own

#### Parameters

- group_name<~String> - Name of the security group, must be nil if id is specified
- group_id<~String> - Id of the security group, must be nil if name is specified

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_snapshot(snapshot_id)

Delete a snapshot of an EBS volume that you own

#### Parameters

- snapshot_id<~String> - ID of snapshot to delete

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_spot_datafeed_subscription()

Delete a spot datafeed subscription

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_subnet(subnet_id)

Deletes a subnet from a VPC. You must terminate all running instances in the subnet before deleting it, otherwise Amazon VPC returns an error

#### Parameters

- subnet_id<~String> - The ID of the Subnet you want to delete.

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

delete_tags(resources, tags)

Remove tags from resources

#### Parameters

- resources<~String> - One or more resources to remove tags from
- tags<~String> - hash of key value tag pairs to remove

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_volume(volume_id)

Delete an EBS volume

#### Parameters

- volume_id<~String> - Id of volume to delete.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

delete_vpc(vpc_id)

Deletes a VPC. You must detach or delete all gateways or other objects that are dependent on the VPC first. For example, you must terminate all running instances, delete all VPC security groups (except the default), delete all the route tables (except the default), etc.

#### Parameters

- vpc_id<~String> - The ID of the VPC you want to delete.

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

deregister_image(image_id)

deregister an image

#### Parameters

- image_id<~String> - Id of image to deregister

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘return’<~Boolean> - Returns true if deregistration succeeded
    - ‘requestId’<~String> - Id of request

Amazon API Reference

describe_addresses(filters = {})

Describe all or specified IP addresses.

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘addressesSet’<~Array>:
      - ‘instanceId’<~String> - instance for ip address
      - ‘publicIp’<~String> - ip address for instance

Amazon API Reference

describe_availability_zones(filters = {})

Describe all or specified availability zones

#### Params

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘availabilityZoneInfo’<~Array>:
      - ‘regionName’<~String> - Name of region
      - ‘zoneName’<~String> - Name of zone
      - ‘zoneState’<~String> - State of zone

Amazon API Reference

describe_dhcp_options(filters = {})

Describe all or specified dhcp_options

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘DhcpOptionsSet’<~Array>:
  - ‘dhcpOptionsId’<~String> - The ID of the Dhcp Options
  - ‘dhcpConfigurationSet’<~Array>: - The list of options in the set.
    - ‘key’<~String> - The name of a DHCP option.
    - ‘valueSet’<~Array>: A set of values for a DHCP option.
      - ‘value’<~String> - The value of a DHCP option.
- ‘tagSet’<~Array>: Tags assigned to the resource.
  - ‘key’<~String> - Tag‘s key
  - ‘value’<~String> - Tag‘s value

Amazon API Reference

describe_images(filters = {})

Describe all or specified images.

#### Params

- filters<~Hash> - List of filters to limit results with
  - filters and/or the following
  - ‘ExecutableBy’<~String> - Only return images that the executable_by user has explicit permission to launch
  - ‘ImageId’<~Array> - Ids of images to describe
  - ‘Owner’<~String> - Only return images belonging to owner.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘imagesSet’<~Array>:
      - ‘architecture’<~String> - Architecture of the image
      - ‘blockDeviceMapping’<~Array> - An array of mapped block devices
      - ‘description’<~String> - Description of image
      - ‘imageId’<~String> - Id of the image
      - ‘imageLocation’<~String> - Location of the image
      - ‘imageOwnerAlias’<~String> - Alias of the owner of the image
      - ‘imageOwnerId’<~String> - Id of the owner of the image
      - ‘imageState’<~String> - State of the image
      - ‘imageType’<~String> - Type of the image
      - ‘isPublic’<~Boolean> - Whether or not the image is public
      - ‘kernelId’<~String> - Kernel id associated with image, if any
      - ‘platform’<~String> - Operating platform of the image
      - ‘productCodes’<~Array> - Product codes for the image
      - ‘ramdiskId’<~String> - Ramdisk id associated with image, if any
      - ‘rootDeviceName’<~String> - Root device name, e.g. /dev/sda1
      - ‘rootDeviceType’<~String> - Root device type, ebs or instance-store
      - ‘virtualizationType’<~String> - Type of virtualization

Amazon API Reference

describe_instance_status(filters = {})

docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-DescribeInstanceStatus.html

describe_instances(filters = {})

Describe all or specified instances

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘reservationSet’<~Array>:
      - ‘groupSet’<~Array> - Group names for reservation
      - ‘ownerId’<~String> - AWS Access Key ID of reservation owner
      - ‘reservationId’<~String> - Id of the reservation
      - ‘instancesSet’<~Array>:
        - instance<~Hash>:
          - ‘architecture’<~String> - architecture of image in [i386, x86_64]
          - ‘amiLaunchIndex’<~Integer> - reference to instance in launch group
          - ‘blockDeviceMapping’<~Array>
            - ‘attachTime’<~Time> - time of volume attachment
            - ‘deleteOnTermination’<~Boolean> - whether or not to delete volume on termination
            - ‘deviceName’<~String> - specifies how volume is exposed to instance
            - ‘status’<~String> - status of attached volume
            - ‘volumeId’<~String> - Id of attached volume
          - ‘dnsName’<~String> - public dns name, blank until instance is running
          - ‘imageId’<~String> - image id of ami used to launch instance
          - ‘instanceId’<~String> - id of the instance
          - ‘instanceState’<~Hash>:
            - ‘code’<~Integer> - current status code
            - ‘name’<~String> - current status name
          - ‘instanceType’<~String> - type of instance
          - ‘ipAddress’<~String> - public ip address assigned to instance
          - ‘kernelId’<~String> - id of kernel used to launch instance
          - ‘keyName’<~String> - name of key used launch instances or blank
          - ‘launchTime’<~Time> - time instance was launched
          - ‘monitoring’<~Hash>:
            - ‘state’<~Boolean - state of monitoring
          - ‘placement’<~Hash>:
            - ‘availabilityZone’<~String> - Availability zone of the instance
          - ‘platform’<~String> - Platform of the instance (e.g., Windows).
          - ‘productCodes’<~Array> - Product codes for the instance
          - ‘privateDnsName’<~String> - private dns name, blank until instance is running
          - ‘privateIpAddress’<~String> - private ip address assigned to instance
          - ‘rootDeviceName’<~String> - specifies how the root device is exposed to the instance
          - ‘rootDeviceType’<~String> - root device type used by AMI in [ebs, instance-store]
          - ‘ramdiskId’<~String> - Id of ramdisk used to launch instance
          - ‘reason’<~String> - reason for most recent state transition, or blank

Amazon API Reference

describe_internet_gateways(filters = {})

Describe all or specified internet_gateways

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘InternetGatewaySet’<~Array>:
  - ‘internetGatewayId’<~String> - The ID of the Internet gateway.
  - ‘attachmentSet’<~Array>: - A list of VPCs attached to the Internet gateway
    - ‘vpcId’<~String> - The ID of the VPC the Internet gateway is attached to
    - ‘state’<~String> - The current state of the attachment
- ‘tagSet’<~Array>: Tags assigned to the resource.
  - ‘key’<~String> - Tag‘s key
  - ‘value’<~String> - Tag‘s value

Amazon API Reference

describe_key_pairs(filters = {})

Describe all or specified key pairs

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘keySet’<~Array>:
      - ‘keyName’<~String> - Name of key
      - ‘keyFingerprint’<~String> - Fingerprint of key

Amazon API Reference

describe_network_interface_attribute(network_interface_id, attribute)

Describes a network interface attribute value

#### Parameters

- network_interface_id<~String> - The ID of the network interface you want to describe an attribute of
- attribute<~String> - The attribute to describe, must be one of ‘description’, ‘groupSet’, ‘sourceDestCheck’ or ‘attachment‘

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘networkInterfaceId’<~String> - The ID of the network interface
- ‘description’<~String> - The description (if requested)
- ‘groupSet’<~Hash> - Associated security groups (if requested)
- ‘key’<~String> - ID of associated group
- ‘value’<~String> - Name of associated group
- ‘sourceDestCheck’<~Boolean> - Flag indicating whether traffic to or from the instance is validated (if requested)
- ‘attachment’<~Hash>: - Describes the way this nic is attached (if requested)
- ‘attachmentID’<~String>
- ‘instanceID’<~String>
- ‘instanceOwnerId’<~String>
- ‘deviceIndex’<~Integer>
- ‘status’<~String>
- ‘attachTime’<~String>
- ‘deleteOnTermination<~Boolean>

Amazon API Reference

describe_network_interfaces(filters = {})

Describe all or specified network interfaces

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘networkInterfaceSet’<~Array>:
- ‘networkInterfaceId’<~String> - The ID of the network interface
- ‘subnetId’<~String> - The ID of the subnet
- ‘vpcId’<~String> - The ID of the VPC
- ‘availabilityZone’<~String> - The availability zone
- ‘description’<~String> - The description
- ‘ownerId’<~String> - The ID of the person who created the interface
- ‘requesterId’<~String> - The ID ot teh entity requesting this interface
- ‘requesterManaged’<~String> -
- ‘status’<~String> - "available" or "in-use"
- ‘macAddress’<~String> -
- ‘privateIpAddress’<~String> - IP address of the interface within the subnet
- ‘privateDnsName’<~String> - The private DNS name
- ‘sourceDestCheck’<~Boolean> - Flag indicating whether traffic to or from the instance is validated
- ‘groupSet’<~Hash> - Associated security groups
- ‘key’<~String> - ID of associated group
- ‘value’<~String> - Name of associated group
- ‘attachment’<~Hash>: - Describes the way this nic is attached
- ‘attachmentID’<~String>
- ‘instanceID’<~String>
- ‘instanceOwnerId’<~String>
- ‘deviceIndex’<~Integer>
- ‘status’<~String>
- ‘attachTime’<~String>
- ‘deleteOnTermination’<~Boolean>
- ‘association’<~Hash>: - Describes an eventual instance association
- ‘attachmentID’<~String> - ID of the network interface attachment
- ‘instanceID’<~String> - ID of the instance attached to the network interface
- ‘publicIp’<~String> - Address of the Elastic IP address bound to the network interface
- ‘ipOwnerId’<~String> - ID of the Elastic IP address owner
- ‘tagSet’<~Array>: - Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value

Amazon API Reference

describe_placement_groups(filters = {})

Describe all or specified placement groups

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘placementGroupSet’<~Array>:
      - ‘groupName’<~String> - Name of placement group
      - ‘strategy’<~String> - Strategy of placement group
      - ‘state’<~String> - State of placement group

Amazon API Reference

describe_regions(filters = {})

Describe all or specified regions

#### Params

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘regionInfo’<~Array>:
      - ‘regionName’<~String> - Name of region
      - ‘regionEndpoint’<~String> - Service endpoint for region

Amazon API Reference

describe_reserved_instances(filters = {})

Describe all or specified reserved instances

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘reservedInstancesSet’<~Array>:
      - ‘availabilityZone’<~String> - availability zone of the instance
      - ‘duration’<~Integer> - duration of reservation, in seconds
      - ‘fixedPrice’<~Float> - purchase price of reserved instance
      - ‘instanceType’<~String> - type of instance
      - ‘instanceCount’<~Integer> - number of reserved instances
      - ‘productDescription’<~String> - reserved instance description
      - ‘reservedInstancesId’<~String> - id of the instance
      - ‘start’<~Time> - start time for reservation
      - ‘state’<~String> - state of reserved instance purchase, in .[pending-payment, active, payment-failed, retired]
      - ‘usagePrice"<~Float> - usage price of reserved instances, per hour

Amazon API Reference

describe_reserved_instances_offerings(filters = {})

Describe all or specified reserved instances offerings

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘reservedInstancesOfferingsSet’<~Array>:
      - ‘availabilityZone’<~String> - availability zone of offering
      - ‘duration’<~Integer> - duration, in seconds, of offering
      - ‘fixedPrice’<~Float> - purchase price of offering
      - ‘instanceType’<~String> - instance type of offering
      - ‘productDescription’<~String> - description of offering
      - ‘reservedInstancesOfferingId’<~String> - id of offering
      - ‘usagePrice’<~Float> - usage price of offering, per hour

Amazon API Reference

describe_security_groups(filters = {})

Describe all or specified security groups

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘securityGroupInfo’<~Array>:
      - ‘groupDescription’<~String> - Description of security group
      - ‘groupId’<~String> - ID of the security group.
      - ‘groupName’<~String> - Name of security group
      - ‘ipPermissions’<~Array>:
        - ‘fromPort’<~Integer> - Start of port range (or -1 for ICMP wildcard)
        - ‘groups’<~Array>:
          - ‘groupName’<~String> - Name of security group
          - ‘userId’<~String> - AWS User Id of account
        - ‘ipProtocol’<~String> - Ip protocol, must be in [‘tcp’, ‘udp’, ‘icmp’]
        - ‘ipRanges’<~Array>:
          - ‘cidrIp’<~String> - CIDR range
        - ‘toPort’<~Integer> - End of port range (or -1 for ICMP wildcard)
      - ‘ownerId’<~String> - AWS Access Key Id of the owner of the security group

Amazon API Reference

describe_snapshots(filters = {}, options = {})

Describe all or specified snapshots

#### Parameters

- filters<~Hash> - List of filters to limit results with
- options<~Hash>:
  - ‘Owner’<~String> - Owner of snapshot in [‘self’, ‘amazon’, account_id]
  - ‘RestorableBy’<~String> - Account id of user who can create volumes from this snapshot

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘snapshotSet’<~Array>:
      - ‘progress’<~String>: The percentage progress of the snapshot
      - ‘snapshotId’<~String>: Id of the snapshot
      - ‘startTime’<~Time>: Timestamp of when snapshot was initiated
      - ‘status’<~String>: Snapshot state, in [‘pending’, ‘completed’]
      - ‘volumeId’<~String>: Id of volume that snapshot contains

Amazon API Reference

describe_spot_datafeed_subscription()

Describe spot datafeed subscription

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘spotDatafeedSubscription’<~Hash>:
      - ‘bucket’<~String> - S3 bucket where data is stored
      - ‘fault’<~Hash>:
        - ‘code’<~String> - fault code
        - ‘reason’<~String> - fault reason
      - ‘ownerId’<~String> - AWS id of account owner
      - ‘prefix’<~String> - prefix for datafeed items
      - ‘state’<~String> - state of datafeed subscription

Amazon API Reference

describe_spot_instance_requests(filters = {})

Describe all or specified spot instance requests

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘spotInstanceRequestSet’<~Array>:
      - ‘createTime’<~Time> - time of instance request creation
      - ‘instanceId’<~String> - instance id if one has been launched to fulfill request
      - ‘launchedAvailabilityZone’<~String> - availability zone of instance if one has been launched to fulfill request
      - ‘launchSpecification’<~Hash>:
        - ‘blockDeviceMapping’<~Hash> - list of block device mappings for instance
        - ‘groupSet’<~String> - security group(s) for instance
        - ‘keyName’<~String> - keypair name for instance
        - ‘imageId’<~String> - AMI for instance
        - ‘instanceType’<~String> - type for instance
        - ‘monitoring’<~Boolean> - monitoring status for instance
      - ‘productDescription’<~String> - general description of AMI
      - ‘spotInstanceRequestId’<~String> - id of spot instance request
      - ‘spotPrice’<~Float> - maximum price for instances to be launched
      - ‘state’<~String> - spot instance request state
      - ‘type’<~String> - spot instance request type

Amazon API Reference

describe_spot_price_history(filters = {})

Describe all or specified spot price history

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘spotPriceHistorySet’<~Array>:
      - ‘availabilityZone’<~String> - availability zone for instance
      - ‘instanceType’<~String> - the type of instance
      - ‘productDescription’<~String> - general description of AMI
      - ‘spotPrice’<~Float> - maximum price to launch one or more instances
      - ‘timestamp’<~Time> - date and time of request creation

Amazon API Reference

describe_subnets(filters = {})

Describe all or specified subnets

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘subnetSet’<~Array>:
- ‘subnetId’<~String> - The Subnet‘s ID
- ‘state’<~String> - The current state of the Subnet. [‘pending’, ‘available’]
- ‘vpcId’<~String> - The ID of the VPC the subnet is in
- ‘cidrBlock’<~String> - The CIDR block the Subnet covers.
- ‘availableIpAddressCount’<~Integer> - The number of unused IP addresses in the subnet (the IP addresses for any stopped instances are considered unavailable)
- ‘availabilityZone’<~String> - The Availability Zone the subnet is in.
- ‘tagSet’<~Array>: Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value
- ‘instanceTenancy’<~String> - The allowed tenancy of instances launched into the Subnet.

Amazon API Reference

describe_tags(filters = {})

Describe all or specified tags

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘tagSet’<~Array>:
      - ‘resourceId’<~String> - id of resource tag belongs to
      - ‘resourceType’<~String> - type of resource tag belongs to
      - ‘key’<~String> - Tag‘s key
      - ‘value’<~String> - Tag‘s value

Amazon API Reference

describe_volume_status(filters = {})

docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-DescribeVolumeStatus.html

describe_volumes(filters = {})

Describe all or specified volumes.

#### Parameters

- filters<~Hash> - List of filters to limit results with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘volumeSet’<~Array>:
      - ‘availabilityZone’<~String> - Availability zone for volume
      - ‘createTime’<~Time> - Timestamp for creation
      - ‘size’<~Integer> - Size in GiBs for volume
      - ‘snapshotId’<~String> - Snapshot volume was created from, if any
      - ‘status’<~String> - State of volume
      - ‘volumeId’<~String> - Reference to volume
      - ‘attachmentSet’<~Array>:
        - ‘attachmentTime’<~Time> - Timestamp for attachment
        - ‘deleteOnTermination’<~Boolean> - Whether or not to delete volume on instance termination
        - ‘device’<~String> - How value is exposed to instance
        - ‘instanceId’<~String> - Reference to attached instance
        - ‘status’<~String> - Attachment state
        - ‘volumeId’<~String> - Reference to volume

Amazon API Reference

describe_vpcs(filters = {})

Describe all or specified vpcs

#### Parameters

- filters<~Hash> - List of filters to limit results with

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘vpcSet’<~Array>:
- ‘vpcId’<~String> - The VPC‘s ID
- ‘state’<~String> - The current state of the VPC. [‘pending’, ‘available’]
- ‘cidrBlock’<~String> - The CIDR block the VPC covers.
- ‘dhcpOptionsId’<~String> - The ID of the set of DHCP options.
- ‘tagSet’<~Array>: Tags assigned to the resource.
- ‘key’<~String> - Tag‘s key
- ‘value’<~String> - Tag‘s value
- ‘instanceTenancy’<~String> - The allowed tenancy of instances launched into the VPC.

Amazon API Reference

detach_internet_gateway(internet_gateway_id, vpc_id)

Detaches an Internet gateway to a VPC, enabling connectivity between the Internet and the VPC

#### Parameters

- internet_gateway_id<~String> - The ID of the Internet gateway to detach
- vpc_id<~String> - The ID of the VPC

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

detach_network_interface(attachment_id, force = false)

Detaches a network interface.

#### Parameters

- attachment_id<~String> - ID of the attachment to detach
- force<~Boolean> - Set to true to force a detachment

### Returns

- response<~Excon::Response>:
- body<~Hash>:
- ‘requestId’<~String> - Id of request
- ‘return’<~Boolean> - Returns true if the request succeeds.

Amazon API Reference

detach_volume(volume_id, options = {})

Detach an Amazon EBS volume from a running instance

#### Parameters

- volume_id<~String> - Id of amazon EBS volume to associate with instance
- options<~Hash>:
  - ‘Device’<~String> - Specifies how the device is exposed to the instance (e.g. "/dev/sdh")
  - ‘Force’<~Boolean> - If true forces detach, can cause data loss/corruption
  - ‘InstanceId’<~String> - Id of instance to associate volume with

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘attachTime’<~Time> - Time of attachment was initiated at
    - ‘device’<~String> - Device as it is exposed to the instance
    - ‘instanceId’<~String> - Id of instance for volume
    - ‘requestId’<~String> - Id of request
    - ‘status’<~String> - Status of volume
    - ‘volumeId’<~String> - Reference to volume

Amazon API Reference

disassociate_address(public_ip=nil, association_id=nil)

Disassociate an elastic IP address from its instance (if any)

#### Parameters

- public_ip<~String> - Public ip to assign to instance
- association_id<~String> - Id associating eip to an network interface

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

get_console_output(instance_id)

Retrieve console output for specified instance

#### Parameters

- instance_id<~String> - Id of instance to get console output from

#### Returns

# * response<~Excon::Response>:

      * body<~Hash>:
        * 'instanceId'<~String> - Id of instance
        * 'output'<~String> - Console output
        * 'requestId'<~String> - Id of request
        * 'timestamp'<~Time> - Timestamp of last update to output

Amazon API Reference

get_password_data(instance_id)

Retrieves the encrypted administrator password for an instance running Windows.

#### Parameters

- instance_id<~String> - A Windows instance ID

#### Returns

# * response<~Excon::Response>:

      * body<~Hash>:
        * 'instanceId'<~String> - Id of instance
        * 'passwordData'<~String> - The encrypted, base64-encoded password of the instance.
        * 'requestId'<~String> - Id of request
        * 'timestamp'<~Time> - Timestamp of last update to output

See docs.amazonwebservices.com/AWSEC2/2010-08-31/APIReference/index.html?ApiReference-query-GetPasswordData.html

Amazon API Reference

import_key_pair(key_name, public_key_material)

Import an existing public key to create a new key pair

#### Parameters

- key_name<~String> - Unique name for key pair.
- public_key_material<~String> - RSA public key

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘keyFingerprint’<~String> - SHA-1 digest of DER encoded private key
    - ‘keyName’<~String> - Name of key
    - ‘requestId’<~String> - Id of request

Amazon API Reference

modify_image_attribute(image_id, attributes)

Modify image attributes

#### Parameters

- image_id<~String> - Id of machine image to modify
- attributes<~Hash>:
  - ‘Add.Group’<~Array> - One or more groups to grant launch permission to
  - ‘Add.UserId’<~Array> - One or more account ids to grant launch permission to
  - ‘Description.Value’<String> - New description for image
  - ‘ProductCode’<~Array> - One or more product codes to add to image (these can not be removed)
  - ‘Remove.Group’<~Array> - One or more groups to revoke launch permission from
  - ‘Remove.UserId’<~Array> - One or more account ids to revoke launch permission from

Amazon API Reference

modify_image_attributes(*params)
modify_instance_attribute(instance_id, attributes)

Modify instance attributes

#### Parameters

- instance_id<~String> - Id of instance to modify
- attributes<~Hash>: ‘InstanceType.Value’<~String> - New instance type ‘Kernel.Value’<~String> - New kernel value ‘Ramdisk.Value’<~String> - New ramdisk value ‘UserData.Value’<~String> - New userdata value ‘DisableApiTermination.Value’<~Boolean> - Change api termination value ‘InstanceInitiatedShutdownBehavior.Value’<~String> - New instance initiated shutdown behaviour, in [‘stop’, ‘terminate’] ‘SourceDestCheck.Value’<~Boolean> - New sourcedestcheck value ‘GroupId’<~Array> - One or more groups to add instance to (VPC only)

Amazon API Reference

modify_instance_attributes(instance_id, attributes)
modify_network_interface_attribute(network_interface_id, attribute, value)

Modifies a network interface attribute value

#### Parameters

- network_interface_id<~String> - The ID of the network interface you want to describe an attribute of
- attribute<~String> - The attribute to modify, must be one of ‘description’, ‘groupSet’, ‘sourceDestCheck’ or ‘attachment‘
- value<~Object> - New value of attribute, the actual tyep depends on teh attribute:

                                      description     - a string
                                      groupSet        - a list of group id's
                                      sourceDestCheck - a boolean value
                                      attachment      - a hash with:
                                                          attachmentid - the attachment to change
                                                          deleteOnTermination - a boolean

Amazon API Reference

modify_snapshot_attribute(snapshot_id, attributes)

Modify snapshot attributes

#### Parameters

- snapshot_id<~String> - Id of snapshot to modify
- attributes<~Hash>:
  - ‘Add.Group’<~Array> - One or more groups to grant volume create permission to
  - ‘Add.UserId’<~Array> - One or more account ids to grant volume create permission to
  - ‘Remove.Group’<~Array> - One or more groups to revoke volume create permission from
  - ‘Remove.UserId’<~Array> - One or more account ids to revoke volume create permission from

Amazon API Reference

monitor_instances(instance_ids)

Monitor specified instance docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-MonitorInstances.html

#### Parameters

- instance_ids<~Array> - Arrays of instances Ids to monitor

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘instancesSet’: docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-ItemType-MonitorInstancesResponseSetItemType.html

Amazon API Reference

purchase_reserved_instances_offering(reserved_instances_offering_id, instance_count = 1)

Purchases a Reserved Instance for use with your account.

#### Parameters

- reserved_instances_offering_id<~String> - ID of the Reserved Instance offering you want to purchase.
- instance_count<~Integer> - The number of Reserved Instances to purchase.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘reservedInstancesId’<~String> - Id of the purchased reserved instances.

Amazon API Reference

reboot_instances(instance_id = [])

Reboot specified instances

#### Parameters

- instance_id<~Array> - Ids of instances to reboot

#### Returns

# * response<~Excon::Response>:

      * body<~Hash>:
        * 'requestId'<~String> - Id of request
        * 'return'<~Boolean> - success?

Amazon API Reference

register_image(name, description, location, block_devices=[], options={})

Amazon API Reference

release_address(ip_or_allocation)

Release an elastic IP address.

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

non-VPC: requires public_ip only

        VPC: requires allocation_id only

reload()
request_spot_instances(image_id, instance_type, spot_price, options = {})

Launch specified instances

#### Parameters

- ‘image_id’<~String> - Id of machine image to load on instances
- ‘instance_type’<~String> - Type of instance
- ‘spot_price’<~Float> - maximum hourly price for instances launched
- options<~Hash>:
  - ‘AvailabilityZoneGroup’<~String> - specify whether or not to launch all instances in the same availability group
  - ‘InstanceCount’<~Integer> - maximum number of instances to launch
  - ‘LaunchGroup’<~String> - whether or not to launch/shutdown instances as a group
  - ‘LaunchSpecification.BlockDeviceMapping’<~Array>: array of hashes
    - ‘DeviceName’<~String> - where the volume will be exposed to instance
    - ‘VirtualName’<~String> - volume virtual device name
    - ‘Ebs.SnapshotId’<~String> - id of snapshot to boot volume from
    - ‘Ebs.NoDevice’<~String> - specifies that no device should be mapped
    - ‘Ebs.VolumeSize’<~String> - size of volume in GiBs required unless snapshot is specified
    - ‘Ebs.DeleteOnTermination’<~String> - specifies whether or not to delete the volume on instance termination
  - ‘LaunchSpecification.KeyName’<~String> - Name of a keypair to add to booting instances
  - ‘LaunchSpecification.Monitoring.Enabled’<~Boolean> - Enables monitoring, defaults to disabled
  - ‘LaunchSpecification.Placement.AvailabilityZone’<~String> - Placement constraint for instances
  - ‘LaunchSpecification.SecurityGroup’<~Array> or <~String> - Name of security group(s) for instances, not supported in VPC
  - ‘LaunchSpecification.SecurityGroupId’<~Array> or <~String> - Id of security group(s) for instances, use this or LaunchSpecification.SecurityGroup
  - ‘LaunchSpecification.UserData’<~String> - Additional data to provide to booting instances
  - ‘Type’<~String> - spot instance request type in [‘one-time’, ‘persistent’]
  - ‘ValidFrom’<~Time> - start date for request
  - ‘ValidUntil’<~Time> - end date for request

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘spotInstanceRequestSet’<~Array>:
      - ‘createTime’<~Time> - time of instance request creation
      - ‘instanceId’<~String> - instance id if one has been launched to fulfill request
      - ‘launchedAvailabilityZone’<~String> - availability zone of instance if one has been launched to fulfill request
      - ‘launchSpecification’<~Hash>:
        - ‘blockDeviceMapping’<~Hash> - list of block device mappings for instance
        - ‘groupSet’<~String> - security group(s) for instance
        - ‘keyName’<~String> - keypair name for instance
        - ‘imageId’<~String> - AMI for instance
        - ‘instanceType’<~String> - type for instance
        - ‘monitoring’<~Boolean> - monitoring status for instance
      - ‘productDescription’<~String> - general description of AMI
      - ‘spotInstanceRequestId’<~String> - id of spot instance request
      - ‘spotPrice’<~Float> - maximum price for instances to be launched
      - ‘state’<~String> - spot instance request state
      - ‘type’<~String> - spot instance request type

Amazon API Reference

reset_network_interface_attribute(network_interface_id, attribute)

Resets a network interface attribute value

#### Parameters

- network_interface_id<~String> - The ID of the network interface you want to describe an attribute of
- attribute<~String> - The attribute to reset, only ‘sourceDestCheck’ is supported.

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

revoke_security_group_ingress(group_name, options = {})

Remove permissions from a security group

#### Parameters

- group_name<~String> - Name of group, optional (can also be specifed as GroupName in options)
- options<~Hash>:
  - ‘GroupName’<~String> - Name of security group to modify
  - ‘GroupId’<~String> - Id of security group to modify
  - ‘SourceSecurityGroupName’<~String> - Name of security group to authorize
  - ‘SourceSecurityGroupOwnerId’<~String> - Name of owner to authorize

  or

  - ‘CidrIp’<~String> - CIDR range
  - ‘FromPort’<~Integer> - Start of port range (or -1 for ICMP wildcard)
  - ‘IpProtocol’<~String> - Ip protocol, must be in [‘tcp’, ‘udp’, ‘icmp’]
  - ‘ToPort’<~Integer> - End of port range (or -1 for ICMP wildcard)

  or

  - ‘IpPermissions’<~Array>:
    - permission<~Hash>:
      - ‘FromPort’<~Integer> - Start of port range (or -1 for ICMP wildcard)
      - ‘Groups’<~Array>:
        - group<~Hash>:
          - ‘GroupName’<~String> - Name of security group to authorize
          - ‘UserId’<~String> - Name of owner to authorize
      - ‘IpProtocol’<~String> - Ip protocol, must be in [‘tcp’, ‘udp’, ‘icmp’]
      - ‘IpRanges’<~Array>:
        - ip_range<~Hash>:
          - ‘CidrIp’<~String> - CIDR range
      - ‘ToPort’<~Integer> - End of port range (or -1 for ICMP wildcard)

### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘return’<~Boolean> - success?

Amazon API Reference

run_instances(image_id, min_count, max_count, options = {})

Launch specified instances

#### Parameters

- image_id<~String> - Id of machine image to load on instances
- min_count<~Integer> - Minimum number of instances to launch. If this exceeds the count of available instances, no instances will be launched. Must be between 1 and maximum allowed for your account (by default the maximum for an account is 20)
- max_count<~Integer> - Maximum number of instances to launch. If this exceeds the number of available instances, the largest possible number of instances above min_count will be launched instead. Must be between 1 and maximum allowed for you account (by default the maximum for an account is 20)
- options<~Hash>:
  - ‘Placement.AvailabilityZone’<~String> - Placement constraint for instances
  - ‘Placement.GroupName’<~String> - Name of existing placement group to launch instance into
  - ‘Placement.Tenancy’<~String> - Tenancy option in [‘dedicated’, ‘default’], defaults to ‘default‘
  - ‘BlockDeviceMapping’<~Array>: array of hashes
    - ‘DeviceName’<~String> - where the volume will be exposed to instance
    - ‘VirtualName’<~String> - volume virtual device name
    - ‘Ebs.SnapshotId’<~String> - id of snapshot to boot volume from
    - ‘Ebs.VolumeSize’<~String> - size of volume in GiBs required unless snapshot is specified
    - ‘Ebs.DeleteOnTermination’<~String> - specifies whether or not to delete the volume on instance termination
  - ‘ClientToken’<~String> - unique case-sensitive token for ensuring idempotency
  - ‘DisableApiTermination’<~Boolean> - specifies whether or not to allow termination of the instance from the api
  - ‘SecurityGroup’<~Array> or <~String> - Name of security group(s) for instances (not supported for VPC)
  - ‘SecurityGroupId’<~Array> or <~String> - id‘s of security group(s) for instances, use this or SecurityGroup
  - ‘InstanceInitiatedShutdownBehaviour’<~String> - specifies whether volumes are stopped or terminated when instance is shutdown, in [stop, terminate]
  - ‘InstanceType’<~String> - Type of instance to boot. Valid options in [‘t1.micro’, ‘m1.small’, ‘m1.large’, ‘m1.xlarge’, ‘c1.medium’, ‘c1.xlarge’, ‘m2.xlarge’, m2.2xlarge’, ‘m2.4xlarge’, ‘cc1.4xlarge’, ‘cc2.8xlarge’, ‘cg1.4xlarge’] default is ‘m1.small‘
  - ‘KernelId’<~String> - Id of kernel with which to launch
  - ‘KeyName’<~String> - Name of a keypair to add to booting instances
  - ‘Monitoring.Enabled’<~Boolean> - Enables monitoring, defaults to disabled
  - ‘PrivateIpAddress<~String> - VPC option to specify ip address within subnet
  - ‘RamdiskId’<~String> - Id of ramdisk with which to launch
  - ‘SubnetId’<~String> - VPC option to specify subnet to launch instance into
  - ‘UserData’<~String> - Additional data to provide to booting instances

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘groupSet’<~Array>: groups the instances are members in
      - ‘groupName’<~String> - Name of group
    - ‘instancesSet’<~Array>: returned instances
      - instance<~Hash>:
        - ‘amiLaunchIndex’<~Integer> - reference to instance in launch group
        - ‘architecture’<~String> - architecture of image in [i386, x86_64]
        - ‘blockDeviceMapping’<~Array>
          - ‘attachTime’<~Time> - time of volume attachment
          - ‘deleteOnTermination’<~Boolean> - whether or not to delete volume on termination
          - ‘deviceName’<~String> - specifies how volume is exposed to instance
          - ‘status’<~String> - status of attached volume
          - ‘volumeId’<~String> - Id of attached volume
        - ‘dnsName’<~String> - public dns name, blank until instance is running
        - ‘imageId’<~String> - image id of ami used to launch instance
        - ‘instanceId’<~String> - id of the instance
        - ‘instanceState’<~Hash>:
          - ‘code’<~Integer> - current status code
          - ‘name’<~String> - current status name
        - ‘instanceType’<~String> - type of instance
        - ‘ipAddress’<~String> - public ip address assigned to instance
        - ‘kernelId’<~String> - Id of kernel used to launch instance
        - ‘keyName’<~String> - name of key used launch instances or blank
        - ‘launchTime’<~Time> - time instance was launched
        - ‘monitoring’<~Hash>:
          - ‘state’<~Boolean - state of monitoring
        - ‘placement’<~Hash>:
          - ‘availabilityZone’<~String> - Availability zone of the instance
        - ‘privateDnsName’<~String> - private dns name, blank until instance is running
        - ‘privateIpAddress’<~String> - private ip address assigned to instance
        - ‘productCodes’<~Array> - Product codes for the instance
        - ‘ramdiskId’<~String> - Id of ramdisk used to launch instance
        - ‘reason’<~String> - reason for most recent state transition, or blank
        - ‘rootDeviceName’<~String> - specifies how the root device is exposed to the instance
        - ‘rootDeviceType’<~String> - root device type used by AMI in [ebs, instance-store]
    - ‘ownerId’<~String> - Id of owner
    - ‘requestId’<~String> - Id of request
    - ‘reservationId’<~String> - Id of reservation

Amazon API Reference

start_instances(instance_id)

Start specified instance

#### Parameters

- instance_id<~Array> - Id of instance to start

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - TODO: fill in the blanks

Amazon API Reference

stop_instances(instance_id, force = false)

Stop specified instance

#### Parameters

- instance_id<~Array> - Id of instance to start

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - TODO: fill in the blanks

Amazon API Reference

terminate_instances(instance_id)

Terminate specified instances

#### Parameters

- instance_id<~Array> - Ids of instances to terminates

#### Returns

# * response<~Excon::Response>:

      * body<~Hash>:
        * 'requestId'<~String> - Id of request
        * 'instancesSet'<~Array>:
          * 'instanceId'<~String> - id of the terminated instance
          * 'previousState'<~Hash>: previous state of instance
            * 'code'<~Integer> - previous status code
            * 'name'<~String> - name of previous state
          * 'shutdownState'<~Hash>: shutdown state of instance
            * 'code'<~Integer> - current status code
            * 'name'<~String> - name of current state

Amazon API Reference

unmonitor_instances(instance_ids)

UnMonitor specified instance docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-query-UnmonitorInstances.html

#### Parameters

- instance_ids<~Array> - Arrays of instances Ids to monitor

#### Returns

- response<~Excon::Response>:
  - body<~Hash>:
    - ‘requestId’<~String> - Id of request
    - ‘instancesSet’: docs.amazonwebservices.com/AWSEC2/latest/APIReference/ApiReference-ItemType-MonitorInstancesResponseSetItemType.html

Amazon API Reference

[Validate]